//
// SegmentsAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Foundation
import Alamofire


open class SegmentsAPI {
    /**
     Get video segments

     - parameter streamId: (query)  
     - parameter tsFrom: (query)  
     - parameter tsTo: (query)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getSegments(streamId: String, tsFrom: Int, tsTo: Int, completion: @escaping ((_ data: SegmentList?,_ error: Error?) -> Void)) {
        getSegmentsWithRequestBuilder(streamId: streamId, tsFrom: tsFrom, tsTo: tsTo).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Get video segments
     - GET /api/v1/segments
     - 

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "segments" : [ {
    "signature" : "signature",
    "ts_end" : 6,
    "segment_url" : "http://example.com/aeiou",
    "ts_start" : 0
  }, {
    "signature" : "signature",
    "ts_end" : 6,
    "segment_url" : "http://example.com/aeiou",
    "ts_start" : 0
  } ]
}}]
     - parameter streamId: (query)  
     - parameter tsFrom: (query)  
     - parameter tsTo: (query)  

     - returns: RequestBuilder<SegmentList> 
     */
    open class func getSegmentsWithRequestBuilder(streamId: String, tsFrom: Int, tsTo: Int) -> RequestBuilder<SegmentList> {
        let path = "/api/v1/segments"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "stream_id": streamId, 
                        "ts_from": tsFrom.encodeToJSON(), 
                        "ts_to": tsTo.encodeToJSON()
        ])


        let requestBuilder: RequestBuilder<SegmentList>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Get segments index file

     - parameter streamId: (query)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getSegmentsIndex(streamId: String, completion: @escaping ((_ data: SegmentIndex?,_ error: Error?) -> Void)) {
        getSegmentsIndexWithRequestBuilder(streamId: streamId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Get segments index file
     - GET /api/v1/segments/index

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "index_url" : "http://example.com/aeiou",
  "signature" : "signature"
}}]
     - parameter streamId: (query)  

     - returns: RequestBuilder<SegmentIndex> 
     */
    open class func getSegmentsIndexWithRequestBuilder(streamId: String) -> RequestBuilder<SegmentIndex> {
        let path = "/api/v1/segments/index"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "stream_id": streamId
        ])


        let requestBuilder: RequestBuilder<SegmentIndex>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
}
